diff --git a/CHANGELOG b/CHANGELOG
index 56b3dd6..f8618ce 100644
--- a/CHANGELOG
+++ b/CHANGELOG
@@ -1,6 +1,7 @@
 ?/?/2006 autofs-5.0.1 rc3
 -------------------------
 - fix handling of autofs specific mount options.
+- fix include check full patch for file map of same name.
 
 1/9/2006 autofs-5.0.1 rc2
 -------------------------
diff --git a/modules/lookup_file.c b/modules/lookup_file.c
index 1bfdeed..c20c976 100644
--- a/modules/lookup_file.c
+++ b/modules/lookup_file.c
@@ -310,6 +310,19 @@ static int check_master_self_include(str
 {
 	char *m_path, *m_base, *i_path, *i_base;
 
+	/*
+	 * If we are including a file map then check the
+	 * full path of the map.
+	 */
+	if (*master->name == '/') {
+		if (!strcmp(master->name, ctxt->mapname))
+			return 1;
+		else
+			return 0;
+	}
+
+	/* Otherwise only check the map name itself. */
+
 	i_path = strdup(ctxt->mapname);
 	if (!i_path)
 		return 0;
